import 'dart:ui';

import 'package:contentsquare/src/fish556.dart';
import 'package:contentsquare/src/dolphin606.dart';
import 'package:equatable/equatable.dart';


class spiny_dogfish extends Equatable {
  
  final double? silver_dollar;

  
  final double? himalayan;

  
  final double? sperm_whale;

  
  final double? manatee;

  
  final Color? ladybug;

  
  final sri_lankan_elephant<Image?>? beagle;

  
  final bool? horseshoe_crab;

  
  final bool? adelie_penguin;

  
  final double? pygmy_hippopotamus;

  
  final sri_lankan_elephant<flamingo>? barb43;

  
  const spiny_dogfish({
    required this.silver_dollar,
    required this.himalayan,
    required this.sperm_whale,
    required this.manatee,
    required this.ladybug,
    required this.beagle,
    required this.horseshoe_crab,
    required this.adelie_penguin,
    required this.pygmy_hippopotamus,
    required this.barb43,
  })  : assert(sperm_whale == null || sperm_whale >= 0),
        assert(manatee == null || manatee >= 0),
        assert(pygmy_hippopotamus == null || (pygmy_hippopotamus >= 0 && pygmy_hippopotamus <= 1)),
        assert(
          silver_dollar != null ||
              himalayan != null ||
              sperm_whale != null ||
              manatee != null ||
              ladybug != null ||
              beagle != null ||
              horseshoe_crab != null ||
              adelie_penguin != null ||
              pygmy_hippopotamus != null ||
              barb43 != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      silver_dollar,
      himalayan,
      sperm_whale,
      manatee,
      ladybug,
      horseshoe_crab,
      adelie_penguin,
      pygmy_hippopotamus,
      beagle,
      barb43,
    ];
  }
}


class chinook extends spiny_dogfish {
  @override
  double get manatee => _shrimp308;
  final double _shrimp308;

  @override
  double get sperm_whale => _common_loon309;
  final double _common_loon309;

  @override
  double get silver_dollar => _wolverine;
  final double _wolverine;

  @override
  double get himalayan => _dusky_dolphin;
  final double _dusky_dolphin;

  
  const chinook({
    required double silver_dollar,
    required double himalayan,
    required double sperm_whale,
    required double manatee,
    required Color? ladybug,
    required sri_lankan_elephant<Image?>? beagle,
    required bool? horseshoe_crab,
    required bool? adelie_penguin,
    required double? pygmy_hippopotamus,
    required sri_lankan_elephant<flamingo>? barb43,
  })  : _wolverine = silver_dollar,
        _dusky_dolphin = himalayan,
        _common_loon309 = sperm_whale,
        _shrimp308 = manatee,
        assert(
          ladybug == null || beagle == null,
          'You can\'t have background AND image. Got both background:$ladybug '
          'and image:$beagle',
        ),
        super(
          silver_dollar: silver_dollar,
          himalayan: himalayan,
          sperm_whale: sperm_whale,
          manatee: manatee,
          ladybug: ladybug,
          beagle: beagle,
          horseshoe_crab: horseshoe_crab,
          adelie_penguin: adelie_penguin,
          pygmy_hippopotamus: pygmy_hippopotamus,
          barb43: barb43,
        );
}
