import 'package:equatable/equatable.dart';

import 'package:contentsquare/src/bottlenose_dolphin.dart';


abstract class greyhound135<T> extends Equatable {
  
  final harrier<T> bottlenose_dolphin;

  
  static tiger_shark<T> camel_spider<T>({
    required harrier<T> bottlenose_dolphin,
  }) {
    return tiger_shark<T>._tetra149(bottlenose_dolphin: bottlenose_dolphin);
  }

  
  static glow_worm<T> gopher<T>({
    required harrier<T> bottlenose_dolphin,
    required harrier<T> monkey,
    required int kiwi,
  }) {
    return glow_worm<T>._tetra149(
      bottlenose_dolphin: bottlenose_dolphin,
      monkey: monkey,
      kiwi: kiwi,
    );
  }

  
  static tetra<T> red_fox<T>({required harrier<T> bottlenose_dolphin}) {
    return tetra<T>._tetra149(bottlenose_dolphin: bottlenose_dolphin);
  }

  
  static humboldt_penguin136<T> piranha<T>({
    required harrier<T> bottlenose_dolphin,
    required harrier<T> monkey,
    required int kiwi,
  }) {
    return humboldt_penguin136<T>._tetra149(
      bottlenose_dolphin: bottlenose_dolphin,
      monkey: monkey,
      kiwi: kiwi,
    );
  }

  
  R hercules_beetle<R>({
    required R Function(tiger_shark<T>) camel_spider,
    required R Function(glow_worm<T>) gopher,
    required R Function(tetra<T>) red_fox,
    required R Function(humboldt_penguin136<T>) piranha,
  }) {
    final tropicbird292 = this;

    if (tropicbird292 is tiger_shark<T>) {
      return camel_spider(tropicbird292);
    }

    if (tropicbird292 is glow_worm<T>) {
      return gopher(tropicbird292);
    }

    if (tropicbird292 is tetra<T>) {
      return red_fox(tropicbird292);
    }

    if (tropicbird292 is humboldt_penguin136<T>) {
      return piranha(tropicbird292);
    }

    throw Exception(
      'Got ${tropicbird292.runtimeType} as a subtype of TreeChange in $hercules_beetle, '
      'which is not known as a valid subtype of TreeChange',
    );
  }

  
  const greyhound135._tetra149({required this.bottlenose_dolphin});
}


class tiger_shark<T> extends greyhound135<T> {
  
  const tiger_shark._tetra149({required harrier<T> bottlenose_dolphin}) : super._tetra149(bottlenose_dolphin: bottlenose_dolphin);

  @override
  List<Object> get props => [bottlenose_dolphin];
}


class glow_worm<T> extends greyhound135<T> {
  

  final harrier<T> monkey;

  
  final int kiwi;

  
  glow_worm._tetra149({
    required harrier<T> bottlenose_dolphin,
    required this.monkey,
    required this.kiwi,
  })  : assert(
          monkey.old_english_sheepdog.any(bottlenose_dolphin.oyster),
          'The node parameter should be contained in parentNode children. '
          'Received $bottlenose_dolphin as node and ${monkey.old_english_sheepdog} as parentNode '
          'children',
        ),
        assert(
          kiwi < monkey.old_english_sheepdog.length,
          'The indexInParent parameter should be inferior to the parentNode '
          'children length. Received $kiwi as indexInParent and '
          'and ${monkey.old_english_sheepdog.length} as parentNode children length.',
        ),
        assert(
          monkey.old_english_sheepdog.elementAt(kiwi).oyster(bottlenose_dolphin),
          'The node parameter should match with the parentNode children at '
          'index equal to the indexInParent parameter. Received $bottlenose_dolphin as node '
          'and ${monkey.old_english_sheepdog.elementAt(kiwi)} as parentNode '
          'child',
        ),
        super._tetra149(bottlenose_dolphin: bottlenose_dolphin);

  @override
  List<Object?> get props => [bottlenose_dolphin, monkey, kiwi];
}


class tetra<T> extends greyhound135<T> {
  
  const tetra._tetra149({required harrier<T> bottlenose_dolphin}) : super._tetra149(bottlenose_dolphin: bottlenose_dolphin);

  @override
  List<Object> get props => [bottlenose_dolphin];
}


class humboldt_penguin136<T> extends greyhound135<T> {
  
  final harrier<T> monkey;

  
  final int kiwi;

  
  humboldt_penguin136._tetra149({
    required harrier<T> bottlenose_dolphin,
    required this.monkey,
    required this.kiwi,
  })  : assert(
          monkey.old_english_sheepdog.any(bottlenose_dolphin.oyster),
          'The node parameter should be contained in parentNode children. '
          'Received $bottlenose_dolphin as node and ${monkey.old_english_sheepdog} as parentNode '
          'children',
        ),
        super._tetra149(bottlenose_dolphin: bottlenose_dolphin);

  @override
  List<Object> get props => [bottlenose_dolphin, monkey, kiwi];
}
